public class CAESAR_Codierer extends Encoder{
  // geheimer Schlssel
  private int key;
  
  // Definition des Alphabets
  public static final int ALPHABETSIZE = 26; 
  public static final char[] alpha = 
		{'A','B','C','D','E','F','G','H','I',
		 'J','K','L','M', 'N','O','P','Q','R',
		 'S','T','U','V','W','X','Y','Z'};
		 
  // bersetzungslisten fr die Buchstaben
  protected char[] encrypt = new char[ALPHABETSIZE];  
  protected char[] decrypt = new char[ALPHABETSIZE];  
    
  public CAESAR_Codierer(int key) {
    this.key = key;	
	computeNewAlphabet();
  }
  
  private void computeNewAlphabet(){
    for (int i=0; i<ALPHABETSIZE; i++) 
      encrypt[i] = alpha[(i + key) % ALPHABETSIZE]; 
	  
    for (int i=0; i<ALPHABETSIZE; i++) 
      decrypt[encrypt[i] - 'A'] = alpha[i]; 
  }
  
  // *************************************************************************
  // Encoder-Funktionen
  public String encode(String s) {
    char[] c = s.toCharArray();     
	
    for (int i=0; i<c.length; i++)      
      if (Character.isUpperCase(c[i]))  
        c[i] = encrypt[c[i] - 'A'];   
		
    return new String(c);
  }

  public String decode(String s){
    char[] c = s.toCharArray(); 
    
    for (int i=0; i<c.length; i++)       
      if (Character.isUpperCase(c[i]))   
        c[i] = decrypt[c[i] - 'A'];   
		
    return new String(c);
  }
  // *************************************************************************
}